#!/usr/bin/python
# -*- coding: utf-8 -*-
#This file is part of Vrrtep CLI
#    Vrrtep CLI is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public Licence as published by
#    the Free Software Foundation, either version 3 of the Licence, or
#    (at your option) any later version.
#
#    Vrrtep CLI is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Vrrtep CLI.  If not, see <http://www.gnu.org/licenses/>
import sys, os, random
from time import sleep

def getValidInt(question, min, max):

    # use a bad value to enter the loop
    value = max + 1

    # compose the prompt
    prompt = question + "[" + str(min) + "-" + str(max) + "]:> "

    # continue to get values until the user enters a valid one
    try:
        while value == "" or value < min or value > max:
            value = raw_input(prompt)
            if len(value) != 0:
                try:
                    value = int(value)
                except ValueError:
                    pass
        return value
    except EOFError:
        print
        sys.exit()
    except KeyboardInterrupt:
        print
        sys.exit()
        
#####################################        
#rid chance of duplicate quiz options
#original Autoit code by Swoka Ikran
def ValidateAnswers(answer):
    for x in range(1,3):
        for y in range(1,3):
            if x == y:
                continue # Prevent checking the answer against itself.
            if answer[x] == answer[y]:
                return False #Reject them since we have duplicates
    return True #They're acceptable, use them.
#####################################

def GetNewAnswers(fileb):
    infile2 = os.path.join(os.path.dirname(sys.argv[0]), fileb)
    file2 = open(infile2, 'r')
    f2content = file2.readlines()
    
    #set up options
    ONE=random.randint(0, len(f2content)-1)
    TWO=random.randint(0, len(f2content)-1)
    THREE=random.randint(0, len(f2content)-1)
    options = [ONE,TWO,THREE]
    
    return options

def quiz(filea,fileb):
    infile1 = os.path.join(os.path.dirname(sys.argv[0]), filea)
    infile2 = os.path.join(os.path.dirname(sys.argv[0]), fileb)
    file1 = open(infile1, 'r')
    file2 = open(infile2, 'r')
    
    f1content = file1.readlines()
    f2content = file2.readlines()
    count = 0.0
    correct = 0.0
    score = 0
    while count < len(f1content):
        os.system('cls')
    
        wordnum = random.randint(0, len(f1content)-1)
   
        print 'Word:', unicode(f1content[wordnum],"utf-8",'ignore'), ''
        
        ####################################
        #choose answers, returns a list with indices 1,2,3 as answers
        #original Autoit code by Swoka Ikran#
        options = GetNewAnswers(fileb)
        while not ValidateAnswers(options):
            options = GetNewAnswers(fileb)
        #####################################
            
        #randomly decide which option is the answer
        options[random.randint(0, 2)] = wordnum
        
    
        print '1 -', unicode(f2content[options[0]],"utf-8",'ignore'),
        print '2 -', unicode(f2content[options[1]],"utf-8",'ignore'),
        print '3 -', unicode(f2content[options[2]],"utf-8",'ignore')

        answer = getValidInt('vrrtep',1,5)
    
        if answer == 4:
            count += 1
            score = correct / count * 100
            print 'ans:',unicode(f2content[wordnum],"utf-8"),
            print 'score:',int(correct),"/",int(count),"(",score,'% )\n'
            sleep(1.75)
        elif answer == 5:
            count += 1
            score = correct / count * 100
            break
        elif options[answer-1] == wordnum:
            count += 1
            correct = correct + 1
            score = correct / count * 100
            print'\nSrane! >:D','score:',int(correct),"/",int(count),"(",score,'% )\n'
            sleep(1.5)
        else:
            count += 1
            score = correct / count * 100
            print "\nKehe. >:\\ ",'score:',int(correct),"/",int(count),"(",score,'% )\n'
            sleep(1.5)

    print 'score:',int(correct),"/",int(count),"(",score,'% )\n'
