#!/usr/bin/python
# -*- coding: utf-8 -*-
#    Vrrtep CLI is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public Licence as published by
#    the Free Software Foundation, either version 3 of the Licence, or
#    (at your option) any later version.
#
#    Vrrtep CLI is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Vrrtep CLI.  If not, see <http://www.gnu.org/licenses/>

import sys
import os
from rhyme import navRhyme
from quiz import quiz
from scramble import game

##arguments##
if sys.argv[-1].startswith('-'):
    params = sys.argv[1:]
else:
    params = sys.argv[1:-1]
##file IO##
try:
    metaWords = open(os.path.join(os.path.dirname(sys.argv[0]), "metaWords.txt"),"r")
except IOError:
    metaWords = open(raw_input("filepath of metaWords.txt? : "),"r")
try:
    localizedWords = open(os.path.join(os.path.dirname(sys.argv[0]), "localizedWords.txt"),"r")
except IOError:
    localizedWords = open(raw_input("filepath of localizedWords.txt? : "),"r")
###TRANSLTATOR###
def getnavid(wordin):
    navid = 'ERROR'
    for line in metaWords:
        inword = ';'+ wordin +';'
        uin=inword.decode("latin-1")
        uin=uin.encode("utf-8")
        if uin in line:
            metaLine = line
            navid = metaLine[0:metaLine.index(';')]
            break
    return navid
def getlocid(wordin,lang):
    idlist = []
    for line in localizedWords:
        inword = ';'+ wordin + ';'
        endword = r'//' + wordin + ';'
        wordcomma = ';' + wordin + ','
        wordspace = ';' + wordin + ' '
        spacecomma = ' ' + wordin + ','
        spaceword = ' '+ wordin + ';'
#        spwordsp = ' ' + wordin + ' '
        if lang in line and inword in line:
            localizedLine = line
            locid = localizedLine[0:localizedLine.index(';')]
            idlist.append(locid)
        elif lang in line and wordcomma in line:
            localizedLine = line
            locid = localizedLine[0:localizedLine.index(';')]
            idlist.append(locid)
        elif lang in line and wordspace in line:
            localizedLine = line
            locid = localizedLine[0:localizedLine.index(';')]
            idlist.append(locid)
        elif lang in line and spaceword in line:
            localizedLine = line
            locid = localizedLine[0:localizedLine.index(';')]
            idlist.append(locid)
#        elif lang in line and spwordsp in line:
#            localizedLine = line
#            locid = localizedLine[0:localizedLine.index(';')]
#            idlist.append(locid)
        elif lang in line and spacecomma in line:
            localizedLine = line
            locid = localizedLine[0:localizedLine.index(';')]
            idlist.append(locid)
        elif lang in line and endword in line:
            localizedLine = line
            locid = localizedLine[0:localizedLine.index(';')]
            idlist.append(locid)
    return idlist
def outfix(word):
    wordfixes = []
    fixtrans = []
    infix = {'<äp>':'reflexive','<eyk>':'causative','<äpeyk>':'reflexive+causative'}
    infix1 = {'<am>':'past','<alm>':'past perfective','<arm>':'past impefective'}
    infix1.update({'<ìm>':'recent past','<ìlm>':'recent past perfective'})
    infix1.update({'<ìrm>':'recent past imperfective','<ìm>':'recent past'})
    infix1.update({'<ol>':'perfective','<er>':'imperfective'})
    infix1.update({'<imv>':'past subjunctive','<ilv>':'perfective subjunctive','<irv>':'imperfective subjunctive'})
    infix1.update({'<iv>':'subjunctive','<ìy>':'near future','<ìry>':'near future imperfective'})
    infix1.update({'<ìly>':'near future perfective','<ìsy>':'near future determined'})
    infix1.update({'<ìyev>':'future subjunctive','<ay>':'future','<ary>':'future imperfective'})
    infix1.update({'<aly>':'future perfective','<asy>':'future determined'})
    infix1.update({'<iyev>':'future subjunctive','<us>':'active participle','<awn>':'passive participle'})
    infix2 = {'<ei>':'laudative','<äng>':'pejorative','<ats>':'inferential'}
    infix2.update({'<uy>':'ceremonial'})
    for i in infix.keys():
        if i in word:
            wordfixes.append(i)
            fixtrans.append(infix[i])
    for i in infix1.keys():
        if i in word:
            wordfixes.append(i)
            fixtrans.append(infix1[i])
    for i in infix2.keys():
        if i in word:
            wordfixes.append(i)
            fixtrans.append(infix2[i])
    for fix in wordfixes:
        word = word.replace(fix,'')
    return word,fixtrans
#def antiprefix(word):
#    prefixes = []
#    fixtrans = []
#    prefix = {'ay':'plural','a':'postadj','fì':'this','fay':'these','fne':'type of','fra':'every','kaw':'not one','me':'two','pay':'what(plural)','pxe':'three','tsa':'that','tsay':'those'}
#    derive = {'le':'adj.','nì':'adv','sä':'instrumental','tì':'noun',}

#    return word,fixtrans
def transnav(navid,lang):
    lst = []
    xstr = ""
    ystr = ""
    zstr = ""
    for line in localizedWords:
        localid = line[0:line.index(';')]
        if navid == localid and lang in line:
            localizedLine = line
            for char in localizedLine:
                lst.append(char)
            semi = lst.index(';')
            lst.remove(';')
            semi2 = lst.index(';')
            lst.remove(';')
            #x is the language
            x = lst[semi:semi2]
            for char in x:
                xstr += str(char)
            semi3 = lst.index(';')
            lst.remove(';')
            #y is local word
            y = lst[semi2:semi3]
            for char in y:
                ystr += str(char)
            #z is the part of speech
            z = lst[semi3:-1]
            for char in z:
                zstr += str(char)
    if navid == "ERROR":
        zstr,ystr = "Not","Found"
    return zstr,ystr
def loctrans(locid):
    lst = []
    xstr = ""
    ystr = "["
    zstr = ""
    zzstr = ""
    for line in metaWords:
        localid = line[0:line.index(';')]
        if locid == localid:
            metaLine = line
            for char in metaLine:
                lst.append(char)
            semi = lst.index(';')
            lst.remove(';')
            semi2 = lst.index(';')
            lst.remove(';')
            #x is the na'vi word
            x = lst[semi:semi2]
            for char in x:
                xstr += str(char)
            semi3 = lst.index(';')
            lst.remove(';')
            xstr = unicode(xstr, "utf-8")
            #y is IPA
            y = lst[semi2:semi3]
            for char in y:
                ystr += str(char)
            ystr += "]"
            semi4 = lst.index(';')
            lst.remove(';')
            #ystr = unicode(ystr, "utf-8")
            #z is the possible infix else \N
            z = lst[semi3:semi4]
            for char in z:
                zstr += str(char)
            zstr = unicode(zstr, "utf-8")
            #zz is the part of speech
            zz = lst[semi4:-1]
            for char in zz:
                zzstr += str(char)
            zzstr = unicode(zzstr, "utf-8")
            if '-ipa' in params and '-i' not in params:
                return zzstr,xstr,ystr
            elif '-i' in params and '-ipa' not in params:
                return zzstr,xstr,zstr
            elif '-ipa' in params and '-i' in params:
                return zzstr,xstr,ystr,zstr
            else:
                return zzstr,xstr
def main():
    if '-s' not in params and '-q' not in params:
        sysarg = ['vrrtepcli.py','./vrrtepcli.py','/usr/local/bin/vrrtepcli']
        if sys.argv[-1].startswith('-') == False and sys.argv[-1] not in sysarg:
            wordin = sys.argv[-1]
            tirea='tun'
        else:
            wordin = raw_input('vrrtep:> ')
            tirea='rim'
        if '<' in wordin:
            tirea = 'ean'
            wordin,infixes = outfix(wordin)
#        else:
#            tirea!="'om"
    #ptbr
    if '-ptbr' in params:
        lang = ';ptbr;'
        uage = 'ptbr'
    #sv
    elif '-sv' in params:
        lang = ';sv;'
        uage = 'sv'
    #hu
    elif '-hu' in params:
        lang = ';hu;'
        uage = 'hu'
    #nl
    elif '-nl' in params:
        lang = ';nl;'
        uage = 'nl'
    #est
    elif '-est' in params:
        lang = ';est;'
        uage = 'est'
    #de
    elif '-de' in params:
        lang = ';de;'
        uage = 'de'
    else:
        lang = ';eng;'
        uage = 'eng'
    if '-n' in params:
        navid = getnavid(wordin)
        pos,defn = transnav(navid,lang)
        if tirea == 'ean':
            print pos,defn,infixes
#        elif tirea == 'teyr':
#            print pos,defn,prefixes
        else:
            print pos,defn
        print
    elif '-l' in params and '-q' not in params:
        idlist = getlocid(wordin,lang)
        print 'Query matches:'
        for locid in idlist:
            if '-ipa' in params and '-i' not in params:
                pos,defn,ipa = loctrans(locid)
                print pos,defn,ipa
            elif '-i' in params and '-ipa' not in params:
                pos,defn,infx = loctrans(locid)
                print pos,defn,infx
            elif '-ipa' in params and '-i' in params:
                pos,defn,uipa,infx = loctrans(locid)
                print pos,defn,uipa,infx
            else:
                pos,defn = loctrans(locid)
                print pos,defn
        print
    elif '-r' in params:
        navRhyme(wordin)
        print
        print
    elif '-q' in params and '-l' in params:
        quiz(uage+'.txt','naviwords.txt')
    elif '-q' in params and '-l' not in params:
        quiz('naviwords.txt',uage+'.txt')
        print
    elif '-s' in params:
        game()
        print
    else:
        navid = getnavid(wordin)
        pos,defn = transnav(navid,lang)
        if tirea == 'ean':
            print pos,defn,infixes
#        elif tirea == 'teyr':
#            print pos,defn,prefixes            
        else:
            print pos,defn
        print
try:
    main()
except EOFError:
    print
    sys.exit()
except KeyboardInterrupt:
    print
    sys.exit()
metaWords.close()
localizedWords.close()
